<?php
namespace YpmPopup;
class Style {

	public function __construct() {

		$this->init();
	}

	public function init() {

	}

	public static function getAllowedPages()
	{
		return array(
			YPM_POPUP_POST_TYPE.'_page_'.YPM_SETTINGS_PAGE
		);
	}

	public static function enqueueStyles($hook) {

		global $post, $YpmPostTypesInfo;
		$currentPostType = '';

		if (!empty($post->post_type)) {
			$currentPostType = $post->post_type;
		}
		$allowedPages = self::getAllowedPages();
		global $YpmPostTypesInfo;
		$popupPostTypes = $YpmPostTypesInfo['postTypes'];
		$isInAllowedPages = in_array($hook, $allowedPages);

		if (!in_array($currentPostType, array_keys($popupPostTypes)) && !$isInAllowedPages) {
			return false;
		}

		ScriptsManager::registerStyle('style.css');
		ScriptsManager::enqueueStyle('style.css');

		ScriptsManager::registerStyle('ypmcolorbox', array(
			'styleSrc' => YPM_POPUP_CSS_URL.'colorbox/',
			'fileName' => 'colorbox.css'
		));
		ScriptsManager::enqueueStyle('ypmcolorbox');

		if($hook == 'post-new.php' || $hook == 'post.php' || $isInAllowedPages) {

			$popupPostTypes = $YpmPostTypesInfo['postTypes'];

			if(!empty($popupPostTypes[$currentPostType]) || $isInAllowedPages) {
				ScriptsManager::registerStyle('ypmbootstrap.css');
				ScriptsManager::enqueueStyle('ypmbootstrap.css');
				ScriptsManager::registerStyle('select2.css');
				ScriptsManager::enqueueStyle('select2.css');
				ScriptsManager::registerStyle('ion.rangeSlider.css');
				ScriptsManager::enqueueStyle('ion.rangeSlider.css');
				ScriptsManager::registerStyle('ion.rangeSlider.skinFlat.css');
				ScriptsManager::enqueueStyle('ion.rangeSlider.skinFlat.css');
				wp_enqueue_style( 'wp-color-picker' ); 
			}
		}
	}
}