<?php
use YpmPopup\ScriptsManager;

class JsInluder {

	public function __construct() {
		
		add_action('admin_enqueue_scripts', array($this, 'ypmEnqueueScripts'));
	}

	public function ypmEnqueueScripts($hook) {

		global $post, $YpmPostTypesInfo;
		$currentPostType = '';
		if (!empty($post->post_type)) {
			$currentPostType = $post->post_type;
		}
		global $YpmPostTypesInfo;
		$popupPostTypes = $YpmPostTypesInfo['postTypes'];

		if (!in_array($currentPostType, array_keys($popupPostTypes))) {
			return false;
		}
		wp_enqueue_script('jquery');
		ScriptsManager::loadScript('jquery.colorbox.js');
		ScriptsManager::registerScript('YpmReviewPopup.js', array('dirUrl' => YPM_POPUP_ADMIN_JS_URL));
		ScriptsManager::enqueueScript('YpmReviewPopup.js');

		ScriptsManager::registerScript('ypmAdminJs.js', array('dep' => array('jquery', 'wp-color-picker')));
		ScriptsManager::localizeScript('ypmAdminJs.js', 'YpmAdminParams', array(
			'ajaxNonce' => wp_create_nonce('ypmPmNonce'),
			'copied' => __('Copied', YPM_POPUP_TEXT_DOMAIN),
			'areYouSure' => __('Are you sure?', YPM_POPUP_TEXT_DOMAIN),
			'copyToClipboard' => __('Copy to clipboard', YPM_POPUP_TEXT_DOMAIN)
		));
		ScriptsManager::enqueueScript('ypmAdminJs.js');

		if ($hook == 'post-new.php' || $hook == 'post.php') {
			if(function_exists('wp_enqueue_code_editor')) {
				wp_enqueue_code_editor(array( 'type' => 'text/html'));
			}
			$popupPostTypes = $YpmPostTypesInfo['postTypes'];

			if (!empty($popupPostTypes[$post->post_type])) {
				wp_register_script('ionRangeSlider', YPM_POPUP_JS_URL . '/ionRangeSlider.js', array('jquery', 'wp-color-picker'));
				wp_enqueue_script('ionRangeSlider');
				wp_register_script('select2', YPM_POPUP_JS_URL . '/select2.js');
				wp_enqueue_script('select2');
				wp_register_script('bootstrapmin', YPM_POPUP_JS_URL . '/bootstrap.min.js');
				wp_enqueue_script('bootstrapmin');
			}
		}
	}
}

new JsInluder();