function YpmAdminJs() {

	this.colorpicker();
	this.accordion();
	this.upgradePro();
	this.select2();
	this.tabEvenetsListener();
	this.copySortCode();
	this.editor();

	this.livePreview();
	this.multipleChoiceButton();
	this.resetViewCount();
}

YpmAdminJs.prototype.copySortCode = function() {
	jQuery('.ypm-shortcode-input').bind('click', function() {
		var currentId = jQuery(this).data('id');
		var copyText = document.getElementById('ypm-shortcode-input-'+currentId);
		copyText.select();
		document.execCommand('copy');

		var tooltip = document.getElementById('ypm-tooltip-'+currentId);
		tooltip.innerHTML = YpmAdminParams.copied;
	});

	jQuery(document).on('focusout', '.countdown-shortcode',function() {
		var currentId = jQuery(this).data('id');
		var tooltip = document.getElementById('ypm-tooltip-'+currentId);
		tooltip.innerHTML = YpmAdminParams.copyToClipboard;
	});
};

YpmAdminJs.prototype.tabEvenetsListener = function() {

	if (!jQuery('.nav-tabs a').length) {
		return false;
	}

	jQuery('.nav-tabs a').bind('click', function (e) {
		e.preventDefault();
		jQuery('.nav.nav-tabs li').removeClass('active');
		jQuery(this).parent().addClass('active');
		jQuery('.tab-pane.fade').removeClass('in active');
		var id = jQuery(this).attr('href');
		jQuery(id).addClass('in active');
	});
};

YpmAdminJs.prototype.select2 = function () {
	if (!jQuery('.js-basic-select').length) {
		return false;
	}
	jQuery('.js-basic-select').select2();
};

YpmAdminJs.prototype.colorpicker = function() {

	if (!jQuery("#range").length) {
		return false;
	}
	jQuery('.ypm-color-picker').wpColorPicker();

	jQuery("#range").ionRangeSlider({
		hide_min_max: true,
		keyboard: true,
		min: 0,
		max: 1,
		type: 'single',
		step: 0.1,
		prefix: "",
		grid: true
	});
};

YpmAdminJs.prototype.accordion = function () {

	var that = this;
	var element = jQuery(".js-ypm-accordion");
	element.each(function() {
		that.checkboxAccordion(jQuery(this));
	});

	element.click(function() {
		var elements = jQuery(this);
		that.checkboxAccordion(jQuery(this));
	});
};

YpmAdminJs.prototype.checkboxAccordion = function (element) {

	if(!element.is(':checked')) {
		element.parents('.row').first().nextAll("div").first().css({'display': 'none'});
	}
	else {
		element.parents('.row').first().nextAll("div").first().css({'display':'block'});
	}
};

YpmAdminJs.prototype.upgradePro = function () {
	jQuery('.yrm-pro-options').on('click', function() {
		window.open('http://devfelixmoira.epizy.com/');
	});
};

YpmAdminJs.prototype.editor = function() {
	(function($){
		$(function(){

			if( $('#ypm-editor-js').length ) {
				var editorSettings = wp.codeEditor.defaultSettings ? _.clone( wp.codeEditor.defaultSettings ) : {};
				editorSettings.codemirror = _.extend(
					{},
					editorSettings.codemirror,
					{
						mode: 'javascript',
					}
				);
				var editor = wp.codeEditor.initialize( $('#ypm-editor-js'), editorSettings );
			}

			if( $('#ypm-editor-css').length ) {
				var editorSettings = wp.codeEditor.defaultSettings ? _.clone( wp.codeEditor.defaultSettings ) : {};
				editorSettings.codemirror = _.extend(
					{},
					editorSettings.codemirror,
					{
						indentUnit: 2,
						tabSize: 2,
						mode: 'css',
					}
				);
				var editor = wp.codeEditor.initialize( $('#ypm-editor-css'), editorSettings );
			}
		});
	})(jQuery);
};

YpmAdminJs.prototype.livePreview = function ()
{
	var previewHeader = jQuery('.ypm-live-preview-text');

	if (!previewHeader.length) {
		return false;
	}
	previewHeader.bind('click', function () {
		var toggleIcon = jQuery('.ypm-toggle-icon');
		if (toggleIcon.hasClass('ypm-toggle-icon-open')) {
			toggleIcon.removeClass('ypm-toggle-icon-open').addClass('ypm-toggle-icon-close');
		}
		else {
			toggleIcon.removeClass('ypm-toggle-icon-close').addClass('ypm-toggle-icon-open');
		}
		jQuery('.ypm-live-preview-content').toggle();
	});

};

YpmAdminJs.prototype.multipleChoiceButton = function() {
	var choiceOptions = jQuery('.ypm-choice-option-wrapper input');
	if(!choiceOptions.length) {
		return false;
	}

	var that = this;

	choiceOptions.each(function() {

		if(jQuery(this).is(':checked')) {
			that.buildChoiceShowOption(jQuery(this));
		}

		jQuery(this).on('change', function() {
			that.hideAllChoiceWrapper(jQuery(this).parents('.ypm-multichoice-wrapper').first());
			that.buildChoiceShowOption(jQuery(this));
		});
	})
};


YpmAdminJs.prototype.hideAllChoiceWrapper = function(choiceOptionsWrapper) {
	choiceOptionsWrapper.find('input').each(function() {
		var choiceInputWrapperId = jQuery(this).attr('data-attr-href');
		jQuery('#'+choiceInputWrapperId).addClass('ypm-hide');
	})
};

YpmAdminJs.prototype.buildChoiceShowOption = function(currentRadioButton)  {
	var choiceOptions = currentRadioButton.attr('data-attr-href');
	var currentOptionWrapper = currentRadioButton.parents('.ypm-choice-wrapper').first();
	var choiceOptionWrapper = jQuery('#'+choiceOptions).removeClass('ypm-hide');
	currentOptionWrapper.after(choiceOptionWrapper);
};

YpmAdminJs.prototype.resetViewCount = function()  {
	var resetButton = jQuery('.ypm-reset-count-btn');

	if (!resetButton.length) {
		return false;
	}

	resetButton.bind('click', function () {

		if (!confirm(YpmAdminParams.areYouSure)) {
			return false;
		}

		var data = {
			postId: jQuery(this).data('id'),
			action: "ypm_reset_view_count",
			nonce: YpmAdminParams.ajaxNonce
		};

		jQuery.post(ajaxurl, data, function(response) {
			window.location.reload();
		});
	});
};

jQuery(document).ready(function() {
	var obj = new YpmAdminJs();
});