<?php
class YpmPopupData {

	public static function popupDefaultData() {

		$dataArray = array();
		$dataArray['ypm-popup-width'] = '';
		$dataArray['ypm-popup-height'] = '';

 		return apply_filters('YpmDefaultDataValues', $dataArray);
	}

	public static function popupOptionsKeys() {

		$popupOptions = self::popupDefaultData();
		if(empty($popupOptions)) {
			return array();
		}
		$popupOptionsName = array_keys($popupOptions);

		return $popupOptionsName;
	}

	public static function defaultsData() {

		$defaults = array();

		$defaults['themes'] = array(
			'colorbox1',
			'colorbox2',
			'colorbox3',
			'colorbox4',
			'colorbox5'
		);

		$defaults['fbButtons'] = array(
			'likeButton' => __('Like Button', YPM_POPUP_TEXT_DOMAIN),
			'shareButton' => __('Share Button', YPM_POPUP_TEXT_DOMAIN)
		);

		$defaults['contactFormTabs'] = array(
			'fields' => __('Contact form fields', YPM_POPUP_TEXT_DOMAIN),
			'design' => __('Contact form design', YPM_POPUP_TEXT_DOMAIN),
			'submitOption' => __('Submit Options', YPM_POPUP_TEXT_DOMAIN),
			'options' => __('Options', YPM_POPUP_TEXT_DOMAIN)
		);

		$defaults['youtubeColors'] = array(
			'read' => __('Read', YPM_POPUP_TEXT_DOMAIN),
			'white' => __('White', YPM_POPUP_TEXT_DOMAIN)
		);

		$defaults['youtube-after-expire'] =array(
			'template' => array(
				'fieldWrapperAttr' => array(
					'class' => 'col-md-6 ypm-choice-option-wrapper'
				),
				'labelAttr' => array(
					'class' => 'col-md-6 ypm-choice-option-wrapper'
				),
				'groupWrapperAttr' => array(
					'class' => 'row form-group ypm-choice-wrapper'
				)
			),
			'buttonPosition' => 'right',
			'nextNewLine' => true,
			'fields' => array(
				array(
					'attr' => array(
						'type' => 'radio',
						'name' => 'ypm-popup-expiration-behavior',
						'class' => 'ypm-countdown-hide-behavior ypm-form-radio',
						'data-attr-href' => 'ypm-popup-expiration-default',
						'value' => 'default'
					),
					'label' => array(
						'name' => __('Default', YPM_POPUP_TEXT_DOMAIN)
					)
				),
				array(
					'attr' => array(
						'type' => 'radio',
						'name' => 'ypm-popup-expiration-behavior',
						'class' => 'ypm-popup-hide-behavior ypm-form-radio',
						'data-attr-href' => 'ypm-popup-expiration-redirect',
						'value' => 'redirect'
					),
					'label' => array(
						'name' => __('Redirect', YPM_POPUP_TEXT_DOMAIN)
					)
				),
				array(
					'attr' => array(
						'type' => 'radio',
						'name' => 'ypm-popup-expiration-behavior',
						'class' => 'ypm-countdown-hide-behavior ypm-form-radio',
						'data-attr-href' => 'ypm-popup-expiration-hide',
						'value' => 'hide'
					),
					'label' => array(
						'name' => __('Hide', YPM_POPUP_TEXT_DOMAIN)
					)
				),
			)
		);

		$defaults['contact-form-after-expire'] =array(
			'template' => array(
				'fieldWrapperAttr' => array(
					'class' => 'col-md-6 ypm-choice-option-wrapper'
				),
				'labelAttr' => array(
					'class' => 'col-md-6 ypm-choice-option-wrapper'
				),
				'groupWrapperAttr' => array(
					'class' => 'row form-group ypm-choice-wrapper'
				)
			),
			'buttonPosition' => 'right',
			'nextNewLine' => true,
			'fields' => array(
				array(
					'attr' => array(
						'type' => 'radio',
						'name' => 'ypm-popup-contacted-behavior',
						'class' => 'ypm-countdown-hide-behavior ypm-form-radio',
						'data-attr-href' => 'ypm-popup-contact-message',
						'value' => 'message'
					),
					'label' => array(
						'name' => __('Message', YPM_POPUP_TEXT_DOMAIN)
					)
				),
				array(
					'attr' => array(
						'type' => 'radio',
						'name' => 'ypm-popup-contacted-behavior',
						'class' => 'ypm-popup-hide-behavior ypm-form-radio',
						'data-attr-href' => 'ypm-popup-contact-redirect',
						'value' => 'redirect'
					),
					'label' => array(
						'name' => __('Redirect', YPM_POPUP_TEXT_DOMAIN)
					)
				),
				array(
					'attr' => array(
						'type' => 'radio',
						'name' => 'ypm-popup-contacted-behavior',
						'class' => 'ypm-countdown-hide-behavior ypm-form-radio',
						'data-attr-href' => 'ypm-popup-expiration-hide',
						'value' => 'hide'
					),
					'label' => array(
						'name' => __('Hide', YPM_POPUP_TEXT_DOMAIN)
					)
				),
			)
		);

		return apply_filters('YpmDefaultDataOptions', $defaults);
	}
}